<?php

namespace Drupal\eca_condition\Service;

use Drupal\eca\Event\BaseHookHandler;

/**
 * Hook Handler for Token ECA Alter.
 *
 * @package Drupal\token_eca_alter\Service
 */
class HookHandler extends BaseHookHandler {

  /**
   * Alter the exist token.
   *
   * @param string $condition_id
   *   The condition id.
   * @param array $arguments
   *   The arguments.
   *
   * @return bool
   *   Execute condition result.
   */
  public function condition(string $condition_id, array $arguments = []): bool {
    /** @var \Drupal\eca_condition\Events\ConditionEvent $event */
    $event = $this->triggerEvent->dispatchFromPlugin('eca_condition:condition_event', $condition_id, $arguments);
    if (empty($event)) {
      return FALSE;
    }
    return $event->getResult();
  }

}
